Framework brl.max2d
Import brl.glmax2d
Import brl.standardio
SetGraphicsDriver(GLMax2DDriver())
Graphics 480, 320, 0, 32

Const colRange:Int = 255

startx:Int = (480 - colRange) / 2
starty:Int = (320 - colRange) / 2

selectedRed:Int = 128
selectedGreen:Int = 0
selectedBlue:Int = 0

Repeat
	Cls
	
	downR:Int = -1
	downG:Int = -1
	downB:Int = -1
	For Local i:Int = 0 To colRange
		For Local i2:Int = 0 To colRange
			If Abs(i - selectedGreen) < 2 And Abs(i2 - selectedBlue) < 2 And (i <> selectedGreen And i2 <> selectedBlue) Then
				SetColor(255 - selectedRed / 2, 255 - i / 2, 255 - i2 / 2)
			Else
				SetColor(selectedRed, i, i2)
			End If
			Plot(startx + i, starty + i2)
			If MouseX() = startx + i And MouseY() = starty + i2 Then
				If MouseDown(MOUSE_LEFT) Then
					downG = i
					downB = i2
				EndIf
			End If
		Next
	Next
	If downG <> - 1 And downB <> - 1 Then
		selectedGreen = downG
		selectedBlue = downB
	End If
	
	For Local ri:Int = 0 To 24
		For Local ri2:Int = 0 To colRange
			If Abs(ri2 - selectedRed) < 1 Then
				SetColor(255 - ri2 / 2, 0, 0)
			Else
				SetColor(ri2, 0, 0)
			End If
			Plot(startx + colRange + 24 + ri, starty + ri2)
			If Abs(MouseX() - (startx + colRange + 48)) < 24 And MouseY() = starty + ri2 Then
				If MouseDown(MOUSE_LEFT) Then downR = ri2
			End If
		Next
	Next
	If downR <> - 1 Then selectedRed = downR
	
	SetColor(255, 255, 255)
	DrawText("Selection:", 24, 10)
	DrawText("Red: " + selectedRed, 24, 26)
	DrawText("Green: " + selectedGreen, 24, 42)
	DrawText("Blue: " + selectedBlue, 24, 58)
	SetColor(selectedRed, selectedGreen, selectedBlue)
	DrawRect(24, 74, 24, 24)
	
	Flip 0
	Delay 20
Until AppTerminate()